package com.diagbot.repository;

import com.diagbot.entity.node.Allergen;
import com.diagbot.entity.node.EntityInfo;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;


public interface AllergenRepository extends Neo4jRepository<Allergen, Long> {

    List<Allergen> findByNameIs(String name);

    List<Allergen> findByNameIn(List<String> names);

    List<Allergen> findByNameContaining(String name);

    @Query("create (n:过敏原) \n" +
            "set  " +
            "n.name = :#{#entityInfo.name}," +
            "n.拼音编码 = :#{#entityInfo.pycode}," +
            "n.静态知识标识 = :#{#entityInfo.is_kl}," +
            "n.状态 = :#{#entityInfo.status}" +
            "\n" +
            "RETURN n,[ (n)-[r]->(m) | [ r, m ] ], ID(n)\n")
    Allergen create(@Param("entityInfo") EntityInfo entityInfo);
}

