package com.diagbot.repository;

import com.diagbot.entity.node.EntityBaseInfo;
import com.diagbot.entity.node.EntityInfo;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * @Description:
 * @Author:zhaops
 * @time: 2020/12/14 13:26
 */
public interface EntityInfoRepository extends Neo4jRepository<EntityBaseInfo,Long> {
    @Query(value = "match(n)\n" +
            "where exists(n.name) and n.name<>''\n" +
            //"any(label in labels(n) where label in {labels})\n" +
            "and (case when {label} is not null and {label} <> '' then\n" +
            "(case {label}\n" +
            "when '医保疾病名称' then n:医保疾病名称 \n " +
            "when '实验室检查套餐名' then n:实验室检查套餐名 \n" +
            "when '实验室检查名称' then n:实验室检查名称 \n" +
            "when '辅助检查名称' then n:辅助检查名称 \n" +
            "when '辅助检查子项目名称' then n:辅助检查子项目名称 \n" +
            "when '药品通用名称' then n:药品通用名称 \n" +
            "when '医保手术和操作名称' then n:医保手术和操作名称 \n" +
            "when '疾病' then n:疾病 \n" +
            "when '实验室检查' then n:实验室检查 \n" +
            "when '化验细项及结果' then n:化验细项及结果 \n" +
            "when '实验室检查危急值' then n:实验室检查危急值 \n" +
            "when '化验提醒指标' then n:化验提醒指标 \n" +
            "when '化验套餐名称' then n:化验套餐名称 \n" +
            "when '辅助检查危急值' then n:辅助检查危急值 \n" +
            "when '辅助检查名称描述' then n:辅助检查名称描述 \n" +
            "when '辅助检查名称结果' then n:辅助检查名称结果 \n" +
            "when '辅检提醒指标' then n:辅检提醒指标 \n" +
            "when '药品代码通用名' then n:药品代码通用名 \n" +
            "when '药品注册名称' then n:药品注册名称 \n" +
            "when '药品类别' then n:药品类别 \n" +
            "when '药品治疗学类别' then n:药品治疗学类别 \n" +
            "when '药品药理学类别' then n:药品药理学类别 \n" +
            "when '药品化学物质类别' then n:药品化学物质类别 \n" +
            "when '服用药品' then n:服用药品 \n" +
            "when '禁忌医疗器械及物品' then n:禁忌医疗器械及物品 \n" +
            "when '性别' then n:性别 \n" +
            "when '体征' then n:体征 \n" +
            "when '症状' then n:症状 \n" +
            "when '临床表现' then n:临床表现 \n" +
            "when '科室' then n:科室 \n" +
            "when '开单项互斥' then n:开单项互斥 \n" +
            "when '禁忌人群' then n:禁忌人群 \n" +
            "when '建议输血提醒' then n:建议输血提醒 \n" +
            "when '药物过敏原' then n:药物过敏原 \n" +
            "when '过敏原' then n:过敏原 \n" +
            "when '食物过敏原' then n:食物过敏原 \n" +
            "when '输血提醒指标' then n:输血提醒指标 \n" +
            "else any(label in labels(n) where label in {labels}) " +
            "end)" +
            "else any(label in labels(n) where label in {labels}) " +
            "end)" +
            "and (case when {name} is not null and {name} <> '' " +
            "then " +
            "((toLower(n.`name`) CONTAINS toLower($name) OR toLower(n.`拼音编码`) CONTAINS toLower($name))) " +
            "else 1 = 1 " +
            "end ) \n" +
            "and (case when {status} is not null " +
            "then " +
            "n.状态 = {status} " +
            "else 1 = 1 " +
            "end ) \n" +
            "and (case when {is_kl} is not null " +
            "then " +
            "n.静态知识标识 = {is_kl} " +
            "else 1 = 1 " +
            "end ) \n" +
            "and not(exists(n.禁忌人群指标)) \n" +
            "and not(exists(n.体征指标)) \n" +
            "and not(exists(n.实验室检查指标)) \n" +
            "return id(n) as id,n.name as name,n.拼音编码  as pycode,labels(n)[0] as labelType,n.状态 as status,n.静态知识标识 as is_kl\n" +
            "order by n.状态 desc, id(n) desc",
            countQuery = "match(n)\n" +
                    "where exists(n.name) and n.name<>''\n" +
                    //"any(label in labels(n) where label in {labels})\n" +
                    "and (case when {label} is not null and {label} <> '' then\n" +
                    "(case {label}\n" +
                    "when '医保疾病名称' then n:医保疾病名称 \n " +
                    "when '实验室检查套餐名' then n:实验室检查套餐名 \n" +
                    "when '实验室检查名称' then n:实验室检查名称 \n" +
                    "when '辅助检查名称' then n:辅助检查名称 \n" +
                    "when '辅助检查子项目名称' then n:辅助检查子项目名称 \n" +
                    "when '药品通用名称' then n:药品通用名称 \n" +
                    "when '医保手术和操作名称' then n:医保手术和操作名称 \n" +
                    "when '疾病' then n:疾病 \n" +
                    "when '实验室检查' then n:实验室检查 \n" +
                    "when '化验细项及结果' then n:化验细项及结果 \n" +
                    "when '实验室检查危急值' then n:实验室检查危急值 \n" +
                    "when '化验提醒指标' then n:化验提醒指标 \n" +
                    "when '化验套餐名称' then n:化验套餐名称 \n" +
                    "when '辅助检查危急值' then n:辅助检查危急值 \n" +
                    "when '辅助检查名称描述' then n:辅助检查名称描述 \n" +
                    "when '辅助检查名称结果' then n:辅助检查名称结果 \n" +
                    "when '辅检提醒指标' then n:辅检提醒指标 \n" +
                    "when '药品代码通用名' then n:药品代码通用名 \n" +
                    "when '药品注册名称' then n:药品注册名称 \n" +
                    "when '药品类别' then n:药品类别 \n" +
                    "when '药品治疗学类别' then n:药品治疗学类别 \n" +
                    "when '药品药理学类别' then n:药品药理学类别 \n" +
                    "when '药品化学物质类别' then n:药品化学物质类别 \n" +
                    "when '服用药品' then n:服用药品 \n" +
                    "when '禁忌医疗器械及物品' then n:禁忌医疗器械及物品 \n" +
                    "when '性别' then n:性别 \n" +
                    "when '体征' then n:体征 \n" +
                    "when '症状' then n:症状 \n" +
                    "when '临床表现' then n:临床表现 \n" +
                    "when '科室' then n:科室 \n" +
                    "when '开单项互斥' then n:开单项互斥 \n" +
                    "when '禁忌人群' then n:禁忌人群 \n" +
                    "when '建议输血提醒' then n:建议输血提醒 \n" +
                    "when '药物过敏原' then n:药物过敏原 \n" +
                    "when '过敏原' then n:过敏原 \n" +
                    "when '食物过敏原' then n:食物过敏原 \n" +
                    "when '输血提醒指标' then n:输血提醒指标 \n" +
                    "else any(label in labels(n) where label in {labels}) " +
                    "end)" +
                    "else any(label in labels(n) where label in {labels}) " +
                    "end)" +
                    "and (case when {name} is not null and {name} <> '' " +
                    "then " +
                    "((toLower(n.`name`) CONTAINS toLower($name) OR toLower(n.`拼音编码`) CONTAINS toLower($name))) " +
                    "else 1 = 1 " +
                    "end ) \n" +
                    "and (case when {status} is not null " +
                    "then " +
                    "n.状态 = {status} " +
                    "else 1 = 1 " +
                    "end ) \n" +
                    "and (case when {is_kl} is not null " +
                    "then " +
                    "n.静态知识标识 = {is_kl} " +
                    "else 1 = 1 " +
                    "end ) \n" +
                    "and not(exists(n.禁忌人群指标)) \n" +
                    "and not(exists(n.体征指标)) \n" +
                    "and not(exists(n.实验室检查指标)) \n" +
                    "return count(*)")
    Page<EntityInfo> getEntityPage(@Param("labels") List<String> labels,
                                   @Param("label") String label,
                                   @Param("name") String name,
                                   @Param("status") Integer status,
                                   @Param("is_kl") Integer is_kl,
                                   Pageable pageable);

    @Query(value = "match(n) where n.name={name} and {label} in labels(n) \n " +
            "return id(n) as id,n.name as name,n.拼音编码  as pycode,labels(n)[0] as labelType,n.状态 as status,n.静态知识标识 as is_kl\n")
    List<EntityInfo> existNodes(@Param("name") String name,
                                @Param("label") String label);

    @Query("merge (n{id:{name}})  " +
            "on create set  " +
            "n.拼音编码={pycode}," +
            "n.静态知识标识={is_kl}," +
            "n.状态={status}," +
            "n.最大值={maxValue}," +
            "n.最小值={minValue}," +
            "n.范围={range}," +
            "n.单位={unit}, " +
            "n.实验室检查指标={indication} " +
            "on match set  " +
            "n.拼音编码={pycode}," +
            "n.静态知识标识={is_kl}," +
            "n.状态={status}," +
            "n.最大值={maxValue}," +
            "n.最小值={minValue}," +
            "n.范围={range}," +
            "n.单位={unit}, " +
            "n.实验室检查指标={indication} " +
            "RETURN n,[ (n)-[r]->(m) | [ r, m ] ], ID(n)\n")
    Boolean updateEntity(@Param("id") Long id);

    @Query(value = "match(n)\n" +
            "where id(n)={id}\n" +
            "return id(n) as id,\n" +
            "n.name as name,\n" +
            "n.拼音编码 as pycode,\n" +
            "n.状态 as status,\n" +
            "n.静态知识标识 as is_kl,\n" +
            "labels(n)[0] as labelType,\n" +
            "n.年龄 as age,\n" +
            "n.age as ageRange,\n" +
            "n.性别 as gender,\n" +
            "n.单位 as unit,\n" +
            "case labels(n)[0] \n" +
            "when \"医保疾病名称\" then n.疾病别称\n" +
            "when \"药物过敏原\" then n.名称\n" +
            "when \"药品注册名称\" then n.名称\n" +
            "end  as alias,\n" +
            "n.结果 as result,\n" +
            "n.最大值 as maxval,\n" +
            "n.最小值 as minval,\n" +
            "n.范围 as range,\n" +
            "n.分类 as category,\n" +
            "n.dept as dept,\n" +
            //"n.年龄max as maxAge,\n" +
            //"n.年龄min as minAge,\n" +
            "n.手术级别 as opgrade,\n" +
            "n.高危条件 as highriskcond,\n" +
            "n.special as special,\n" +
            "n.药品类型 as medtype,\n" +
            "n.药品高危级别 as risklevel,\n" +
            "n.禁忌给药途径 as conflict_geiyao,\n" +
            "n.禁忌性别 as conflict_gender," +
            "n.最小包装数量 as min_pack_num," +
            "n.注册剂型 as reg_JiXin," +
            "n.药品本位码 as benWei_Code," +
            "n.最小包装单位 as min_pack_unit," +
            "n.注册规格 as reg_GuiGe," +
            "n.包装材质 as pack_CaiLiao," +
            "n.药品企业 as producer," +
            "n.批准文号 as license_num," +
            "n.最小制剂单位 as min_prod_unit," +
            "n.标准注册剂型 as stand_reg_JiXin")
    EntityInfo getById(@Param("id") Long id);


    @Query("match (n) \n" +
            "where id(n) = :#{#entityInfo.id} \n" +
            "set  " +
            "n.name = :#{#entityInfo.name}," +
            "n.拼音编码 = :#{#entityInfo.pycode}," +
            "n.静态知识标识 = :#{#entityInfo.is_kl}," +
            "n.状态 = :#{#entityInfo.status}")
    void update(@Param("entityInfo") EntityInfo entityInfo);

    @Query("create (n) \n" +
            "set  " +
            "labels(n)=[:#{#entityInfo.labelType}]," +
            "n.name = :#{#entityInfo.name}," +
            "n.拼音编码 = :#{#entityInfo.pycode}," +
            "n.静态知识标识 = :#{#entityInfo.is_kl}," +
            "n.状态 = :#{#entityInfo.status}" +
            "with id(n) as nodeId\n" +
            "match (n)\n" +
            "where id(n) = nodeId\n" +
            "set labels(n)=[:#{#entityInfo.labelType}]")
    void create(@Param("entityInfo") EntityInfo entityInfo);
}